/*
 * Gauss.h
 *
 * This file is part of the "GaussianLib" project (Copyright (c) 2015 by Lukas Hermanns)
 * See "LICENSE.txt" for license information.
 */

#ifndef GS_GAUSS_H
#define GS_GAUSS_H


#include <Gauss/Config.h>
#include <Gauss/Vector2.h>
#include <Gauss/Vector3.h>
#include <Gauss/Vector4.h>
#include <Gauss/Quaternion.h>
#include <Gauss/Matrix.h>
#include <Gauss/AffineMatrix3.h>
#include <Gauss/AffineMatrix4.h>
#include <Gauss/ProjectionMatrix4.h>
#include <Gauss/Spherical.h>

#include <Gauss/Algebra.h>
#include <Gauss/OStream.h>
#include <Gauss/Epsilon.h>

#include <Gauss/Equals.h>
#include <Gauss/Determinant.h>
#include <Gauss/Inverse.h>
#include <Gauss/Translate.h>
#include <Gauss/Scale.h>
#include <Gauss/Rotate.h>
#include <Gauss/Compare.h>
#include <Gauss/Flip.h>

#include <Gauss/TransformVector.h>
#include <Gauss/RotateVector.h>

#include <Gauss/ScalarType.h>


#endif



// ================================================================================
